####-------- Intersection of bed files --------####
# Autor: Fadwa EL KHADDAR
# Lab : DIADE - IRD
# University : Montpellier - France

####-------- Intersection of bed files --------####
# Autor: Fadwa EL KHADDAR
# Lab : DIADE - IRD
# University : Montpellier - France

import os
import subprocess
import pandas as pd
import matplotlib
import matplotlib.pyplot as plt
from matplotlib_venn import venn2_unweighted
import argparse
import tkinter as tk
from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg
matplotlib.use('TkAgg')

# Arguments
parser = argparse.ArgumentParser(description="Venn Diagram of gff and bed files")
parser.add_argument('-bed1', type=str, help="Path to the first bed file")
parser.add_argument('-bed2', type=str, help="Path to the second bed file")
args = parser.parse_args()

bed1 = args.bed1
bed2 = args.bed2

# Extract file names
filename1 = os.path.splitext(os.path.basename(bed1))[0]
filename2 = os.path.splitext(os.path.basename(bed2))[0]

# Intersection of bed files using bedtools
command2 = subprocess.Popen(f"bedtools intersect -u -a {bed1} -b {bed2}", shell=True, stdout=subprocess.PIPE)
output, error = command2.communicate()
results = output.decode('utf-8').strip()

# Create DataFrame
columns = ["Chro", "Start", "End"]
rows = [line.split('\t') for line in results.split('\n') if line]
df = pd.DataFrame(rows, columns=columns)

# Venn Diagram Construction
count1 = df.shape[0]
count2 = len(pd.read_csv(bed1, sep='\t'))
count3 = len(pd.read_csv(bed2, sep='\t'))

subset = (count2, count3, count1)
venn2_unweighted(subset, set_labels=(filename1, filename2))
fig, ax = plt.subplots()
venn2_unweighted(subset, set_labels=(filename1, filename2), ax=ax)

root = tk.Tk()
root.title("Venn Diagram")

canvas = FigureCanvasTkAgg(fig, master=root)
canvas.draw()
canvas.get_tk_widget().pack(side=tk.TOP, fill=tk.BOTH, expand=1)
root.mainloop()
